function Sd=getpsd(G,P,w,routine)
%
% G(z) .. matrix transfer fn
% P .. input white noise covariance matrix
%
if nargin<4,
  routine='';
end
  
C=chol(P,'lower');
H=G*C;  % does not alter G.a in case of state-space model

N=length(w);
Sd=zeros(N,size(G,1));
for k=1:size(G,1),
  for m=1:size(G,2),
    switch routine
      case ''
	S=ssfreqresp(H(k,m),w);
      case 'ss'
	S=freqresp(H(k,m),w);
      case 'tf'
	S=freqresp(tf(H(k,m)),w);
      case 'zpk'
	S=freqresp(zpk(H(k,m)),w);
    endswitch
    S=abs(S(:)).^2;
    Sd(:,k)=Sd(:,k) + S;
  end
end
